// chassis textures inspired by Zeger Knaepen  no spherical-greebles  http://news.povray.org/povray.binaries.images/attachment/%3C44738fd7@news.povray.org%3E/us-ascii
//______________________________________________________________________________________  // chassis

#declare f_rad_3a = function {pattern {radial}}
#declare f_pig_3a = function {pattern {crackle metric 19 form <1,0,0>}}
#declare f_rad_3 = function {pattern {radial}}
#declare f_pig_3 = function {pattern {crackle metric 999 form <0,1.7,-0.8>}}  

#declare fA = 11.25;

#declare norm_cyl =
pigment {    
        function {f_pig_3 (x-f_rad_3 (x,y,z),y-f_rad_3 (x,y,z),z-f_rad_3 (x,y,z))} 
        scale 0.048      
        color_map {ColorMapScan ("2500_colormaps", 20-1, 256, 1250, 0)}
        #local nCount = 0;
        #while (nCount < 32)
                rotate -fA*z
                warp {repeat y flip y}
                #local nCount = nCount+1;
        #end
}

#declare Kleur =     0.5;
#declare Vuilkleur = 0.3;

#declare Gewoon_vuil =
texture {
	pigment {
	        pigment_pattern {
	                gradient y-z*0.1
	                scale 1.5
	                translate y*0.8
	        }
	        pigment_map {
	                [0.45   granite
		                color_map {
		                	[0      rgb <15,28,2>/255 transmit 0.99]
		                	[1      rgb 0.1*Vuilkleur transmit 0.8]
		                }
		                rotate x*90
		                translate -0.5
		                translate z*2 
		                scale <0.5,0.25,1>*3
		        ]
		        [0.45   granite
		                color_map {
		                	[0      rgb <123,79,6>/355 transmit 0.99]
		                	[1      rgb 0.1*Vuilkleur transmit 0.8]
		                }
		                rotate x*90
		                translate -0.5
		                translate z*2 
		                scale <0.5,0.25,1>*3
		        ]
		        [0.47   granite
		                color_map {
		                	[0      rgb <123,79,6>/355 transmit 0.99]
		                	[1      rgb 0.1*Vuilkleur transmit 0.8]
		                }
		                rotate x*90
		                translate -0.5
		                translate z*2 
		                scale <0.5,0.25,1>*3
		        ]
		        [0.47   granite
		                color_map {
		                	[0      rgb <15,28,2>/255 transmit 0.99]
		                	[1      rgb 0.1*Vuilkleur transmit 0.8]
		                }
		                rotate x*90
		                translate -0.5
		                translate z*2 
		                scale <0.5,0.25,1>*3
		        ] 
	                [0.485  granite
		                color_map {
		                	[0      rgb <15,28,2>/255 transmit 0.99]
		                	[1      rgb 0.1*Vuilkleur transmit 0.8]
		                }
		                rotate x*90
		                translate -0.5
		                translate z*2 
		                scale <0.5,0.25,1>*3
		        ]
		        [0.485  granite
		                color_map {
		                	[0      rgb <123,79,6>/355 transmit 0.99]
		                	[1      rgb 0.1*Vuilkleur transmit 0.8]
		                }
		                rotate x*90
		                translate -0.5
		                translate z*2 
		                scale <0.5,0.25,1>*3
		        ]
		}
	}
	normal {spotted 1 scale 0.0001 accuracy 0.0001}
	finish {
		brilliance 4
		diffuse 0
		emission 0
		metallic
		specular 0.8
		roughness 0.025
		reflection {0.2, 1 metallic}
	}
}

#declare Gewoon_heel_vuil =
texture {
	pigment {
	        pigment_pattern {
	                gradient y-z*0.1
	                scale 1.5
	                translate y*0.8
	        }
	        pigment_map {
	                [0.45   granite
		                color_map {
		                	[0      rgb <15,28,2>/255 transmit 0.99]
		                	[1      rgb 0.1*Vuilkleur transmit 0.6]
		                }
		                rotate x*90
		                translate -0.5
		                translate z*2 
		                scale <0.25,0.125,0.7>*3
		        ]
		        [0.45   granite
		                color_map {
		                	[0      rgb <123,79,6>/355 transmit 0.99]
		                	[1      rgb 0.1*Vuilkleur transmit 0.6]
		                }
		                rotate x*90
		                translate -0.5
		                translate z*2 
		                scale <0.25,0.125,0.7>*3
		        ]
	                [0.47   granite
		                color_map {
		                	[0      rgb <123,79,6>/355 transmit 0.99]
		                	[1      rgb 0.1*Vuilkleur transmit 0.6]
		                }
		                rotate x*90
		                translate -0.5
		                translate z*2 
		                scale <0.25,0.125,0.7>*3
		        ]
		        [0.47   granite
		                color_map {
		                	[0      rgb <15,28,2>/255 transmit 0.99]
		                	[1      rgb 0.1*Vuilkleur transmit 0.6]
		                }
		                rotate x*90
		                translate -0.5
		                translate z*2 
		                scale <0.25,0.125,0.7>*3
		        ]	        
	                [0.485  granite
		                color_map {
		                	[0      rgb <15,28,2>/255 transmit 0.99]
		                	[1      rgb 0.1*Vuilkleur transmit 0.6]
		                }
		                rotate x*90
		                translate -0.5
		                translate z*2 
		                scale <0.25,0.125,0.7>*3
		        ]
		        [0.485  granite
		                color_map {
		                	[0      rgb <123,79,6>/355 transmit 0.99]
		                	[1      rgb 0.1*Vuilkleur transmit 0.6]
		                }
		                rotate x*90
		                translate -0.5
		                translate z*2 
		                scale <0.25,0.125,0.7>*3
		        ]
		}
	}
	normal {spotted 1 scale 0.0001 translate 0.5 accuracy 0.0001}
	finish {
		brilliance 4
		diffuse 0
		emission 0
		metallic
		specular 0.8
		roughness 0.025
		reflection {0.2, 1 metallic}
	}
}

#declare Scar =
texture {
	pigment {
	        pigment_pattern {
	                gradient y-z*0.1
	                scale 1.5
	                translate y*0.8
	        }
	        pigment_map {
	                [0.45   crackle form <1,0,0>
		                color_map {
		                	[0      rgb <15,28,2>/255 transmit 0.8]
		                	[0.2    rgbt <0.1,0.01,0,1>]
		                }
		                scale 0.5
		                turbulence 0.2
		                lambda 3
		                scale 4 
		                scale <0.25,0.25,1>*3
		        ]
		        [0.45   crackle form <1,0,0>
		                color_map {
		                	[0      rgb <123,79,6>/355 transmit 0.8]
		                	[0.2    rgbt <0.1,0.01,0,1>]
		                }
		                scale 0.5
		                turbulence 0.2
		                lambda 3
		                scale 4 
		                scale <0.25,0.25,1>*3
		        ]
	                [0.47   crackle form <1,0,0>
		                color_map {
		                	[0      rgb <123,79,6>/355 transmit 0.8]
		                	[0.2    rgbt <0.1,0.01,0,1>]
		                }
		                scale 0.5
		                turbulence 0.2
		                lambda 3
		                scale 4 
		                scale <0.25,0.25,1>*3
		        ]
		        [0.47   crackle form <1,0,0>
		                color_map {
		                	[0      rgb <15,28,2>/255 transmit 0.8]
		                	[0.2    rgbt <0.1,0.01,0,1>]
		                }
		                scale 0.5
		                turbulence 0.2
		                lambda 3
		                scale 4 
		                scale <0.25,0.25,1>*3
		        ] 
	                [0.485  crackle form <1,0,0>
		                color_map {
		                	[0      rgb <15,28,2>/255 transmit 0.8]
		                	[0.2    rgbt <0.1,0.01,0,1>]
		                }
		                scale 0.5
		                turbulence 0.2
		                lambda 3
		                scale 4 
		                scale <0.25,0.25,1>*3
		        ]
		        [0.485  crackle form <1,0,0>
		                color_map {
		                	[0      rgb <123,79,6>/355 transmit 0.8]
		                	[0.2    rgbt <0.1,0.01,0,1>]
		                }
		                scale 0.5
		                turbulence 0.2
		                lambda 3
		                scale 4 
		                scale <0.25,0.25,1>*3
		        ]
		}
	}	
	normal {
	        average
	        normal_map {
	                [1      dents 0.4 scale <0.25,0.25,1>*3]
	                [1      spotted 1 scale 0.0001 translate -0.5 accuracy 0.0001]
	        }
	}
	finish {
		brilliance 4
		diffuse 0
		emission 0
		metallic
		specular 0.8
		roughness 0.025
		reflection {0.2, 1 metallic}
	}
}

#declare BS = 2;

#declare T_3_ =
material {
	texture {
		pigment {
			average
			pigment_map {
                                [1      pigment_pattern {
                                        	function {f_pig_3a (abs (x)-f_rad_3a (abs (x),y,z), y-f_rad_3a (abs (x),y,z), z-f_rad_3a (abs (x),y,z))}
                                        	scale 0.6
                                        	color_map {
                                                        [0      rgb 0.5]
                                        	        [0.405  rgb 0.5]
                                        	        [0.415  rgb 0]
                                                        [0.595  rgb 0]
                                        	        [0.605  rgb 1]
                                        	        [1      rgb 1]
                                                }            
                                        }
					pigment_map {
						[0      pigment_pattern {
                                                        	function {f_pig_3a (abs (x)-f_rad_3a (abs (x),y,z), y-f_rad_3a (abs (x),y,z), z-f_rad_3a (abs (x),y,z))}
                                                        	scale 0.6
                                                        	color_map {
                                                                        [0      rgb 0.5]
                                                        	        [0.405  rgb 0.5]
                                                        	        [0.415  rgb 0]
                                                                        [0.595  rgb 0]
                                                        	        [0.605  rgb 1]
                                                        	        [1      rgb 1]
                                                                }            
                                                        }
							color_map {
								[0      rgb 0.08*Kleur]
								[1      rgb Kleur]
							}
							scale 0.5
						]
						[0.4    pigment_pattern {
                                                        	function {f_pig_3a (abs (x)-f_rad_3a (abs (x),y,z), y-f_rad_3a (abs (x),y,z), z-f_rad_3a (abs (x),y,z))}
                                                        	scale 0.6
                                                        	color_map {
                                                                        [0      rgb 0.5]
                                                        	        [0.405  rgb 0.5]
                                                        	        [0.415  rgb 0]
                                                                        [0.595  rgb 0]
                                                        	        [0.605  rgb 1]
                                                        	        [1      rgb 1]
                                                                }            
                                                        }
							color_map {
								[0      rgb 0.08*Kleur]
								[1      rgb Kleur]
							}
							translate <0,0.5,0.2>
						]
					}
				]
				[1      pigment_pattern {
                                        	function {f_pig_3a (abs (x)-f_rad_3a (abs (x),y,z), y-f_rad_3a (abs (x),y,z), z-f_rad_3a (abs (x),y,z))}
                                        	scale 0.6
                                        	color_map {
                                                        [0      rgb 0.5]
                                        	        [0.405  rgb 0.5]
                                        	        [0.415  rgb 0]
                                                        [0.595  rgb 0]
                                        	        [0.605  rgb 1]
                                        	        [1      rgb 1]
                                                }            
                                        }
					color_map {
						[0      rgb 0.08*Kleur]
						[1      rgb Kleur]
					}
					translate <0,1.5,0.2>
					scale 2
					translate <0,1.5,3.5>
				]
			}
			scale 0.25
		}
		normal {
			average
			normal_map {
				[1      pigment_pattern {
                                        	function {f_pig_3a (abs (x)-f_rad_3a (abs (x),y,z), y-f_rad_3a (abs (x),y,z), z-f_rad_3a (abs (x),y,z))}
                                        	scale 0.6
                                        	color_map {
                                                        [0      rgb 0.5]
                                        	        [0.405  rgb 0.5]
                                        	        [0.415  rgb 0]
                                                        [0.595  rgb 0]
                                        	        [0.605  rgb 1]
                                        	        [1      rgb 1]
                                                }            
                                        }
					normal_map {
						[0      pigment_pattern {
                                                        	function {f_pig_3a (abs (x)-f_rad_3a (abs (x),y,z), y-f_rad_3a (abs (x),y,z), z-f_rad_3a (abs (x),y,z))}
                                                        	scale 0.6
                                                        	color_map {
                                                                        [0      rgb 0.5]
                                                        	        [0.405  rgb 0.5]
                                                        	        [0.415  rgb 0]
                                                                        [0.595  rgb 0]
                                                        	        [0.605  rgb 1]
                                                        	        [1      rgb 1]
                                                                }            
                                                        }
							bump_size 0.25*BS*1.25
							scale 0.5
						]
						[0.4    pigment_pattern {
                                                        	function {f_pig_3a (abs (x)-f_rad_3a (abs (x),y,z), y-f_rad_3a (abs (x),y,z), z-f_rad_3a (abs (x),y,z))}
                                                        	scale 0.6
                                                        	color_map {
                                                                        [0      rgb 0.5]
                                                        	        [0.405  rgb 0.5]
                                                        	        [0.415  rgb 0]
                                                                        [0.595  rgb 0]
                                                        	        [0.605  rgb 1]
                                                        	        [1      rgb 1]
                                                                }            
                                                        }
							bump_size 0.2*BS*1.25
							translate <0,0.5,0.2>
						]
					}
					triangle_wave
					accuracy 0.001
				]
				[1      pigment_pattern {
                                        	function {f_pig_3a (abs (x)-f_rad_3a (abs (x),y,z), y-f_rad_3a (abs (x),y,z), z-f_rad_3a (abs (x),y,z))}
                                        	scale 0.6
                                        	color_map {
                                                        [0      rgb 0.5]
                                        	        [0.405  rgb 0.5]
                                        	        [0.415  rgb 0]
                                                        [0.595  rgb 0]
                                        	        [0.605  rgb 1]
                                        	        [1      rgb 1]
                                                }            
                                        }
					normal_map {
						[0      pigment_pattern {
                                                        	function {f_pig_3a (abs (x)-f_rad_3a (abs (x),y,z), y-f_rad_3a (abs (x),y,z), z-f_rad_3a (abs (x),y,z))}
                                                        	scale 0.6
                                                        	color_map {
                                                                        [0      rgb 0.5]
                                                        	        [0.405  rgb 0.5]
                                                        	        [0.415  rgb 0]
                                                                        [0.595  rgb 0]
                                                        	        [0.605  rgb 1]
                                                        	        [1      rgb 1]
                                                                }            
                                                        }
							bump_size 0.25*BS*1.25
							scale 0.5
						]
						[0.4    pigment_pattern {
                                                        	function {f_pig_3a (abs (x)-f_rad_3a (abs (x),y,z), y-f_rad_3a (abs (x),y,z), z-f_rad_3a (abs (x),y,z))}
                                                        	scale 0.6
                                                        	color_map {
                                                                        [0      rgb 0.5]
                                                        	        [0.405  rgb 0.5]
                                                        	        [0.415  rgb 0]
                                                                        [0.595  rgb 0]
                                                        	        [0.605  rgb 1]
                                                        	        [1      rgb 1]
                                                                }            
                                                        }
							bump_size 0.2*BS*1.25
							translate <0,0.5,0.2>
						]
					}
					scale 0.25
					triangle_wave
					accuracy 0.001
				]
				[1      pigment_pattern {
                                        	function {f_pig_3a (abs (x)-f_rad_3a (abs (x),y,z), y-f_rad_3a (abs (x),y,z), z-f_rad_3a (abs (x),y,z))}
                                        	scale 0.6
                                        	color_map {
                                                        [0      rgb 0.5]
                                        	        [0.405  rgb 0.5]
                                        	        [0.415  rgb 0]
                                                        [0.595  rgb 0]
                                        	        [0.605  rgb 1]
                                        	        [1      rgb 1]
                                                }            
                                        }
					bump_size 0.125*BS*1.25
					translate <0,1.5,0.2>
					scale 2
					translate <0,1.5,3.5>
					triangle_wave
					accuracy 0.001
				]
		                [1      pigment_pattern {norm_cyl}
        	                	0.14*1.25
        	                	scale 32
        	                	triangle_wave
        	                	accuracy 0.0001
                                ]
                                [1      spotted 0.5 scale 0.0001 translate 2 accuracy 0.0001]
			}
			scale 0.25
		}
	        finish {
	        	brilliance 4
	        	diffuse 0
	        	emission 0
	        	metallic
	        	specular 0.8
	        	roughness 0.025
	        	reflection {0.2, 1 metallic}
	        }
		scale 0.5
	}
	texture {Scar}
	texture {Gewoon_vuil}
	texture {Gewoon_heel_vuil}
	scale 4
	interior {ior 2.4}
}

//____________________________________________________________________________________________________________________________________  // cockpit

#declare Kleur =     <0,1,0.6>*0.25+0.75;
#declare Vuilkleur = <0.4,0.3,0.1>*0.25+0.3;

#declare Gewoon_vuil =
texture {
	pigment {
		granite
		color_map {
			[0      rgb 0.2*Vuilkleur transmit 0.99]
			[1      rgb 0.1*Vuilkleur transmit 0.8]
		}
		rotate x*90
		translate -0.5
		translate z*2
	}
	finish {
		brilliance 4
		diffuse 0
		emission 0
		metallic
		specular 0.8
		roughness 0.025
		reflection {0.2, 1 metallic}
	}
}

#declare Gewoon_heel_vuil =
texture {
	pigment {
		granite
		color_map {
			[0      rgb 0.2*Vuilkleur transmit 0.99]
			[1      rgb 0.1*Vuilkleur transmit 0.6]
		}
		rotate x*90
		translate -0.5
		translate z*2
	}
	finish {
		brilliance 4
		diffuse 0
		emission 0
		metallic
		specular 0.8
		roughness 0.025
		reflection {0.2, 1 metallic}
	}
}

#declare Scar =
texture {
	pigment {
		crackle form <1,0,0>
		color_map {
			[0      rgbt <0.1,0.01,0,0.8>]
			[0.2    rgbt <0.1,0.01,0,1>]
		}
		scale 0.5
		turbulence 0.2
		lambda 3
		scale 4
	}
	normal {dents 0.2}
	finish {
		brilliance 4
		diffuse 0
		emission 0
		metallic
		specular 0.8
		roughness 0.025
		reflection {0.2, 1 metallic}
	}
}

#declare BS = 16;

#declare T_6 =
material {
	texture {
		pigment {
			average
			pigment_map {
				[1      cells
					pigment_map {
						[0      cells
							color_map {
								[0      rgb 0.8*Kleur]
								[1      rgb Kleur]
							}
							scale 0.5
						]
						[0.4    cells
							color_map {
								[0      rgb 0.8*Kleur]
								[1      rgb Kleur]
							}
							translate <0.25,0.5,0.2>
						]
					}
					scale 1
				]
				[1      cells
					color_map {
						[0      rgb 0.8*Kleur]
						[1      rgb Kleur]
					}
					translate <0.25,1.5,0.2>
					scale 2
					translate <2.25,1.5,3.5>
				]
			}
			scale 0.25
		}
		normal {
			average
			normal_map {
				[1      cells
					normal_map {
						[0      cells
							bump_size 0.25*BS
							scale 0.5
						]
						[0.4    cells
							bump_size 0.2*BS
							translate <0.25,0.5,0.2>
						]
					}
				]
				[1      cells
					normal_map {
						[0      cells
							bump_size 0.25*BS
							scale 0.5
						]
						[0.4    cells
							bump_size 0.2*BS
							translate <0.25,0.5,0.2>
						]
					}
					scale 0.25
				]
				[1      cells
					bump_size 0.125*BS
					translate <0.25,1.5,0.2>
					scale 2
					translate <2.25,1.5,3.5>
				]
			}
			scale 0.125/8
			accuracy 0.0001
		}
	        finish {
	        	brilliance 4
	        	diffuse 0
	        	emission 0
	        	metallic
	        	specular 0.8
	        	roughness 0.025
	        	reflection {0.2, 1 metallic}
	        }
		scale 15
	}
	texture {Scar		  scale <0.25,0.250,1>*3}
	texture {Gewoon_vuil      scale <0.50,0.250,1>*3}
	texture {Gewoon_heel_vuil scale <0.25,0.125,0.7>*3}
	scale 4
	interior {ior 2.4}
}

//___________________________________________________________________________  // jet engine

#declare f_rad4 = function {pattern {radial}}
#declare f_pig4 = function {pattern {crackle metric 999 form <0,1.7,-0.8>}}  

#declare fA = 11.25;

#declare norm_cyl =
pigment {    
        function {f_pig4 (x-f_rad4 (x,y,z),y-f_rad4 (x,y,z),z-f_rad4 (x,y,z))} 
        scale 0.048      
        color_map {ColorMapScan ("2500_colormaps", 20-1, 256, 1250, 0)}
        #local nCount = 0;
        #while (nCount < 32)
                rotate -fA*z
                warp {repeat y flip y}
                #local nCount = nCount+1;
        #end
}

#macro MetalMatG (Color)

texture {
	aoi
	texture_map {
		[0      pigment {color srgb Color*1.5} 
		        normal {
		                average
		                normal_map {
		                        [1      pigment_pattern {norm_cyl}
        	                        	0.2
        	                        	triangle_wave
        	                        	accuracy 0.001
                                        ]
                                        [1      spotted 0.4 scale 0.0001]
                                
                                }
                        }
	                finish {
	                	brilliance 4
	                	diffuse 0
	                	emission 0
	                	metallic
	                	specular 0.8
	                	roughness 0.025
	                	reflection {srgb Color}
	                	irid {
        			        0.1
        			        thickness 0.2
        			        turbulence 1
        		        }	                	
	                }
                ]
                [0.4    pigment {color srgb 0}
		        normal {
		                average
		                normal_map {
		                        [1      pigment_pattern {norm_cyl}
        	                        	0.2
        	                        	triangle_wave
        	                        	accuracy 0.001
                                        ]
                                        [1      spotted 0.1 scale 0.0001]
                                
                                }
                        }
	                finish {
	                	brilliance 4
	                	diffuse 0
	                	metallic
	                	specular 0.8
	                	roughness 0.025
	                	reflection {0, 1}
	                }
                ]
                [0.6    pigment {color srgb 0} 
		        normal {
		                average
		                normal_map {
		                        [1      pigment_pattern {norm_cyl}
        	                        	0.2
        	                        	triangle_wave
        	                        	accuracy 0.001
                                        ]
                                        [1      spotted 0.1 scale 0.0001]
                                
                                }
                        }
	                finish {
	                	brilliance 4
	                	diffuse 0
	                	metallic
	                	specular 0.8
	                	roughness 0.025
	                	reflection {0, 1}
	                }
                ]
		[1      pigment {color srgb Color*1.5}
		        normal {
		                average
		                normal_map {
		                        [1      pigment_pattern {norm_cyl}
        	                        	0.2
        	                        	triangle_wave
        	                        	accuracy 0.001
                                        ]
                                        [1      spotted 0.4 scale 0.0001]
                                
                                }
                        }
	                finish {
	                	brilliance 4
	                	diffuse 0
	                	emission 0
	                	metallic
	                	specular 0.8
	                	roughness 0.025
	                	reflection {srgb Color}
	                	irid {
        			        0.1
        			        thickness 0.2
        			        turbulence 1
        		        }
	                }
                ]
	}        
}

#end 

#declare greebleMat =
material {
        MetalMatG (<0.4,0.4,0.4>)
        interior {ior 1.5}
}

//____________________________________________________________________________________________________  // jet blast

#declare T8 =
material {
	texture {
		pigment {color rgbt 1}
	}
	interior {
		ior 1
		media {
                        method 3                                      
                        aa_level 4                                    
                        aa_threshold 0.1                              
                        samples 80                               
                        intervals 1                                   
                        ratio 0.9                                     
                        confidence 0.9                                
                        variance 0.007                                
                        jitter 0                                      
                        emission 30
			density {
				average
				density_map {
					[1      bozo
						poly_wave
						color_map {
							[0      rgb <0,0,0>]
							[0.48   rgb <0,0,0>]
							[0.5    rgb <5,15,20>]
							[0.52   rgb <0,0,0>]
							[1      rgb <0,0,0>]
						}
						scale <0.6,0.8,0.6>
					]
					[1      wrinkles
						color_map {
							[0      rgb <0,0,0>]
							[0.48   rgb <0,0,0>]
							[0.5    rgb <7,5,20>]
							[0.52   rgb <0,0,0>]
							[1      rgb <0,0,0>]
						}
						scale <0.6,0.6,0.6>
						rotate 30*z
					]
				}
			}
			density {
                                radial 
                                turbulence 0
                                frequency 12 
                                color_map {
                                        [0      rgb 0.2]
                                        [0.5    rgb 1.8]
                                        [1      rgb 0.2]
                                }
                        }
		}
	}
	scale 0.35
}

#declare T8_ =
material {
	texture {
		pigment {color rgbt 1}
	}
	interior {
		ior 1
		media {
                        method 3                                      
                        aa_level 4                                    
                        aa_threshold 0.1                              
                        samples 80                               
                        intervals 1                                   
                        ratio 0.9                                     
                        confidence 0.9                                
                        variance 0.007                                
                        jitter 0                                      
                        emission 80
			density {
				average
				density_map {
					[1      bozo
						poly_wave
						color_map {
							[0      rgb <0,0,0>]
							[0.48   rgb <0,0,0>]
							[0.5    rgb <5,15,20>]
							[0.52   rgb <0,0,0>]
							[1      rgb <0,0,0>]
						}
						scale <0.6,0.8,0.6>
					]
					[1      wrinkles
						color_map {
							[0      rgb <0,0,0>]
							[0.48   rgb <0,0,0>]
							[0.5    rgb <7,5,20>]
							[0.52   rgb <0,0,0>]
							[1      rgb <0,0,0>]
						}
						scale <0.6,0.6,0.6>
						rotate 30*z
					]
				}
			}
			density {
                                radial 
                                turbulence 0
                                frequency 12 
                                color_map {
                                        [0      rgb 0.2]
                                        [0.5    rgb 1.8]
                                        [1      rgb 0.2]
                                }
                        }
		}
	}
	scale 0.35
}

#declare T9 =
material {
	texture {
		pigment {color rgbt 1}
	}
	interior {
		ior 1
		media {
                        method 3                                      
                        aa_level 4                                    
                        aa_threshold 0.1                              
                        samples 80                               
                        intervals 1                                   
                        ratio 0.9                                     
                        confidence 0.9                                
                        variance 0.007                                
                        jitter 0                                      
                        emission 7
			density {
				average
				density_map {
					[1      bozo
						poly_wave
						color_map {
							[0      rgb <0,0,0>]
							[0.48   rgb <0,0,0>]
							[0.5    rgb <5,15,20>]
							[0.52   rgb <0,0,0>]
							[1      rgb <0,0,0>]
						}
						scale <0.6,0.8,0.6>
					]
					[1      wrinkles
						color_map {
							[0      rgb <0,0,0>]
							[0.48   rgb <0,0,0>]
							[0.5    rgb <7,5,20>]
							[0.52   rgb <0,0,0>]
							[1      rgb <0,0,0>]
						}
						scale <0.6,0.6,0.6>
						rotate 30*z
					]
				}
			}
			density {
                                cylindrical
                                color_map { 
                                        [0      rgb 0]
                                        [0.2    rgb 0.02]
                                        [0.7    rgb 0.25]
                                        [0.95   rgb 1]  
                                        [0.99   rgb 9*<1,0.9,1.11>]
                                        [1      rgb 0]
                                }
                                warp {                                
                                        turbulence <0.025,0.5,0.025>        
                                        octaves 8                     
                                        lambda 5                      
                                        omega 0.2                     
                                }
                                scale 40*<1,0.1,1>
                        }
                        density {
                                gradient y 
                                turbulence 0.2
                                scale 4 
                                color_map {
                                        [0      rgb 0.1]
                                        [0.5    rgb 1.9]
                                        [1      rgb 0.1]
                                }
                        }
                        density {
                                gradient y 
                                turbulence 0.1
                                scale 55 
                                color_map {
                                        [0      rgb 1]
                                        [0.3    rgb 1]
                                        [1      rgb 0]
                                }
                        }
		}
	}
	scale 0.35
}

//___________________________________________________________________________  // lamps

#declare inter = function {sin (sin (x)+cos (y))+cos (cos (x)+sin (y))}  

#macro shuttle (landed)   

#declare T12 =
material {
	texture {
                pigment {color rgbt 1}
                normal {
                        function {inter (abs (x)*-1,y,z)}
                        -2
                }
	        finish {
	        	diffuse 0
	        	ambient 0
	        }
        }
	interior {
	        ior 1.6
		media {
			#if (landed) 
			        emission 50*<0.3,1,1>
			#else
			        emission 50			
			#end
			samples 80
			density {
                                function {inter (abs (x)*-1,y,z)}
                                color_map {
                                        [0.5    rgb 0]
                                        [0.5    rgb <1,1,0.5>]
                                        [0.9    rgb <1,0,0>]
                                        [1      rgb <1,0,1>]
                                }
			}
		}	        
	}
	scale 0.1
}

#declare T13 =
material {
	texture {
                pigment {color rgbt 1}
        }
	interior {
	        ior 1.6
                media {
                        emission 80
                        density {
                                spherical  
                                color_map {
                                        [0      rgb 0]
                                        [2/3    rgb 0.75]
                                        [1      rgb 20]
                                }
                                scale 2/3
                        }
                }
        }
        scale 0.1
}

//___________________________________________________________________________________________ // chassis
	
#macro ship (Threshold)

blob {
	threshold Threshold
	sphere {0, 2, 1 scale <0.75,0.5,1.25>}
	sphere {0, 2.1, 0.5 scale <0.65,1,1>}
	sphere {0, 2.2, 0.25 scale <.55,1,1>}
	sphere {0, 1, 1 scale <2,0.5,0.5> translate <0,0,-2>}
	cylinder {-z, -z*2, 1, 1}
	sphere {-z*2, 2, 0.2}
	cylinder {<0.5,0,-4>, <0.5,0,-2>, 0.25, -0.5}	
	cylinder {<-0.5,0,-4>, <-0.5,0,-2>, 0.25, -0.5}				
	sphere {<0,0.5,-1.5>, 0.75, -5 scale <0.5,1,1>}
	cylinder {x*0.5, -x*5.5, 1, 1 scale <0.22,0.22,2.5> rotate -z*90 rotate x*-12}
	cylinder {-y*2, y*2, 0.75, -1 scale <1,1,2.5> translate <-1.65,0,-1> rotate -z*45}		
	cylinder {-y*2, y*2, 0.75, -1 scale <1,1,2.5> translate <1.65,0,-1> rotate -z*45}
	cylinder {-y*2, y*2, 0.75, -1 scale <1,1,2.5> translate <-1.65,0,-1> rotate z*45}		
	cylinder {-y*2, y*2, 0.75, -1 scale <1,1,2.5> translate <1.65,0,-1> rotate z*45}
	cylinder {z*10, z*-17, 0.35, 1 scale <1,1,0.1> translate <-0.4,0.25,0.39>}	
	cylinder {z*10, z*-17, 0.35, 1 scale <1,1,0.1> translate <0.4,0.25,0.39>}	
	cylinder {z*10, z*-17, 0.35, 1 scale <1,1,0.1> translate <-0.4,-0.25,0.39>}	
	cylinder {z*10, z*-17, 0.35, 1 scale <1,1,0.1> translate <0.4,-0.25,0.39>}
	cylinder {z*10, z*-7, 0.45, 1 scale <1,1,0.1> translate <0,0.25,0.39>}
	cylinder {z*10, z*-7, 0.45, 1 scale <1,1,0.1> translate <0,-0.15,0.39>}
} 
	
#end

#declare elevon =
union {
        blob {
                threshold 0.1
                sphere {<0,0,0>, 0.925, 1 scale <3,3,1>}
                sphere {<0,0,0>, 1, -0.25 scale <0.5,0.5,2> translate 2.5*y rotate 30*z}  
                sphere {<0,0,0>, 1, -0.25 scale <0.5,0.5,2> translate 2.5*y rotate -30*z}
                sphere {<0,0,0>, 1, -0.25 scale <0.5,0.5,2> translate 2.5*y}    
        } 
        blob {
                threshold 0.1
                sphere {<0,0,0>, 1, 1 scale <3,3,1>}
                sphere {<0,0,0>, 1, -2 scale <2.5,3,2> translate -2.5*y}
                sphere {<0,0,0>, 1, -2 scale <2.5,2,2> translate 3*y}
                sphere {<0,0,0>, 1, -0.16667 scale <0.5,0.5,0.5> translate <0,0.5,-0.875>}
                cylinder {<0,-0.5,0>, <0,1,0>, 0.175, -0.125 scale 200*x}
                cylinder {<0,-0.25,0>, <0,1,0>, 0.175, -0.125 scale 200*x rotate 12*y}
                cylinder {<0,-0.25,0>, <0,1,0>, 0.175, -0.125 scale 200*x rotate -12*y}
        } 
        blob {
                threshold 0.1
                sphere {<0,0,0>, 1, 1 scale <2.5,4,0.9>}
                sphere {<0,0,0>, 1, -2 scale <2,3,2> translate <1,-3,0>}
                sphere {<0,0,0>, 1, -2 scale <2,3,2> translate <-1,-3,0>}
                translate -y
        } 
        blob {
                threshold 0.1
                sphere {<0,0,0>, 1, 1 scale <2.25,3,0.75>}
                sphere {<0,0,0>, 1, -0.5 scale <1,1,2> translate <0,-2.5,0>}
                clipped_by {plane {y, 1}}
                translate -y*1.5
        }   
        blob {
                threshold 0.1
                sphere {<0,0,0>, 1, 1 scale <1.125,2.5,0.5>}
                sphere {<0,0,0>, 1, -0.125 scale <0.25,0.5,2> translate -y*2}
                clipped_by {plane {y, 1}}
                translate -y*2.5
        } 
        scale <0.16,0.4,0.2>
        rotate 90*z
        rotate <50,-90,0>
        translate <0.55,0.65,0.15>
}

#macro LED (LEDcol)

#declare Eye2_Part1 =
union {
        torus {0.5, 0.25 scale <1,4,1>}
        cylinder {-y*2, 0, 0.75} 
}

#declare Eye2_Part2 = cylinder {0, y*1.75, 0.625 scale <1,0.5,1>}

union {
        object {Eye2_Part1}    
        object {
                Eye2_Part2
                pigment {color rgbt 0.9}
                finish {ambient 0 diffuse 2 phong 3}   
                interior {
                        media {
                                emission LEDcol*1000
                                density {
                                        spherical
                                        color_map {
                                                [0      rgb 0]
                                                [2/3    rgb LEDcol]
                                                [1      rgb 20]
                                        }
                                        scale 0.5      
                                        translate 0.75*y
                                }
                        }
                }
                hollow
        }     
        scale 0.025
        rotate -90*x 
        material {T_3_ scale 0.5}
}

#end 

#declare chassis =
union {
	union {
		object {                                                                // chassis
			ship (0.65)
			material {T_3_ translate y scale 0.5*<1,1,0.8>}
	        }
		blob {                                                                  // cockpit
			threshold 0.65
			sphere {
				<0,0,0>, 0.75, 8
				scale <0.5,0.5,1.25>
				rotate -x*10
				translate y*0.5-z*1.5
			}
			material {T_6 scale 10 translate <0,-1.1,0.3>*0}
		}
		union {
		        difference {                                                    // lamps
		                sphere {<0,0,0>, 1}
		                box {<-1.001,-1.001,-1.001>, <0.001,1.001,1.001>}
		                hollow
		                scale <1.7,0.5,0.5>*0.43
		                translate <0,0,-2.2> 
		                material {T12 scale 0.5 rotate z*40 translate <-0.21,0.035,0>}   
		        }
		        #if (! landed)
		                sphere {
		                        <0,0,0>, 0.08
		                        hollow
		                        material {T13}
		                        translate <0.42,0,-2.29>
		                } 
		                sphere {
		                        <0,0,0>, 0.08
		                        hollow
		                        material {T13}
		                        translate <0.57,0,-2.22>
		                }
		        #end
		}
		union {
		        difference {                                                   
		                sphere {<0,0,0>, 1}
		                box {<-1.001,-1.001,-1.001>, <0.001,1.001,1.001>}
		                hollow
		                scale <1.7,0.5,0.5>*0.43
		                translate <0,0,-2.2> 
		                material {T12 scale 0.5 rotate z*40 translate <-0.21,0.035,0>}   
		        }
		        #if (! landed)
		                sphere {
		                        <0,0,0>, 0.08
		                        hollow
		                        material {T13}
		                        translate <0.42,0,-2.29>
		                } 
		                sphere {
		                        <0,0,0>, 0.08
		                        hollow
		                        material {T13}
		                        translate <0.57,0,-2.22>
		                }
		        #end
		        scale <-1,1,1>
		} 
		scale <1,1,1.25>
	}
	object {elevon material {T_3_ translate y scale 0.5}}
	object {elevon scale <-1,1,1> material {T_3_ translate y scale 0.5}}
	#if (! landed)
	        object {LED (<0.6,0.1,0.3>) scale <1,1/0.7,1> rotate <0,0,-15> translate <0,1.05,-1.395>}
	        object {LED (<0.5,0.6,0.1>) scale <1,1/0.7,1> rotate <0,-25,-15> translate <0.03,1.045,-1.39>}
	        object {LED (<0.2,0.1,1>) scale <1,1/0.7,1> rotate <0,-25,-15> translate <0.03,1.045,-1.39> scale <-1,1,1>}
	#else
	        object {LED (<0.1,0.5,0.3>) scale <1,1/0.7,1> rotate <0,0,-15> translate <0,1.05,-1.395>}
	        object {LED (<0.5,0.6,0.1>) scale <1,1/0.7,1> rotate <0,-25,-15> translate <0.03,1.045,-1.39>}
	        object {LED (<0.2,0.1,1>) scale <1,1/0.7,1> rotate <0,-25,-15> translate <0.03,1.045,-1.39> scale <-1,1,1>}
	#end	
}

//____________________________________________________________________________________________________  // jet engine

#declare rm = seed (0);

#declare prop =
union {
        torus {3, 0.5 scale <1,2,1>}
        torus {2.5, 0.5 scale <1,3,1>} 
        torus {1.75, 1 scale <1,2,1>}    
        #if (! landed) 
                cylinder {y*-1, y*1.1, 1.4 hollow material {T8 rotate y*360*rand (rm)}}
                sphere {0, 1.4 translate <0,-1.1,0> hollow material {T8_ rotate y*360*rand (rm)}}
                cone {y*2.6, 2.2, y*20, 0 hollow material {T9 rotate y*360*rand (rm)}}
        #end
        torus {0.75, 1 scale <1,2,1> translate <0,1,0>}
        #declare C = 0;
        #while (C < 360)
                superellipsoid {<0.375, 0.375> scale <0.5,0.5,1> translate <0,1.5,-1.5> rotate C*y}
                #declare C = C+30;
        #end   
        #declare C = 0;
        #while (C < 360)
                superellipsoid {<0.375, 0.375> scale <0.375,0.5,1> translate <0,0.75,-2.25> rotate C*y}
                #declare C = C+20;
        #end                                                                 
        material {greebleMat scale 5 rotate x*90} 
}

#macro eng (C) 

object {prop rotate -90*x scale <2,2,8> translate <-30,0,0> rotate C*z}
union {
        superellipsoid {<0.375, 0.375> translate y scale <0.15,0.75,0.5> translate <-0.25,-0.25,0>} 
        superellipsoid {<0.375, 0.375> translate y scale <0.15,0.75,0.5> translate <0.25,-0.25,0>}  
        superellipsoid {<0.375, 0.375> translate -y scale <0.025,1,0.05> rotate 30*x rotate -80*y translate <0,1,0>} 
        superellipsoid {<0.375, 0.375> translate -y scale <0.025,1,0.05> rotate 30*x rotate 80*y translate <0,1,0>} 
        superellipsoid {<0.375, 0.375> translate -y scale <0.025,1,0.05> rotate 30*x rotate -100*y translate <0,1,0>} 
        superellipsoid {<0.375, 0.375> translate -y scale <0.025,1,0.05> rotate 30*x rotate 100*y translate <0,1,0>}
        rotate 90*z
        scale 10
        translate <-20,0,0>
        rotate C*z
        material {greebleMat scale 5 rotate x*90}
}

#end
                
#declare jets =
union {
        sphere {0, 5 scale <1,1,4> translate <0,-19,-10> material {greebleMat scale 5 rotate x*90}} 
        eng (-22.5)
        eng (22.5)
        eng (157.5)
        eng (202.5)
        scale 0.036
        rotate y*180
        translate <0,0,-0.4>                         
}
 
//____________________________________________________________________________________________________  // front sensors

#declare sensor = 
union {
	blob {
		threshold 0.5
		cylinder {0, -z*0.5, 0.2, 1}
		cylinder {0, -z, 0.1, 1}
		cylinder {0, -z*1.5, 0.05, -1}
		cylinder {<0,-1,-0.75>, <0,1,-0.75>, 0.025, -1}
		cylinder {<0,-1,-0.85>, <0,1,-0.85>, 0.025, -1}
		cylinder {<0,-1,-0.95>, <0,1,-0.95>, 0.025, -1}
		cylinder {<0,-1,-0.75>, <0,1,-0.75>, 0.025, -1 rotate z*90}
		cylinder {<0,-1,-0.85>, <0,1,-0.85>, 0.025, -1 rotate z*90}
		cylinder {<0,-1,-0.95>, <0,1,-0.95>, 0.025, -1 rotate z*90}
		cylinder {<0,-1,-0.8>, <0,1,-0.8>, 0.025, -1 rotate z*45}
		cylinder {<0,-1,-0.9>, <0,1,-0.9>, 0.025, -1 rotate z*45}
		cylinder {<0,-1,-0.8>, <0,1,-0.8>, 0.025, -1 rotate -z*45}
		cylinder {<0,-1,-0.9>, <0,1,-0.9>, 0.025, -1 rotate -z*45}
		sphere {0, 2, -0.15 scale <1,1,0.025> translate <0,0,-0.5>}
		sphere {0, 2, -0.15 scale <1,1,0.025> translate <0,0,-0.25>}
		sphere {0, 2, -0.15 scale <1,1,0.025> translate <0,0,-0.125>}
		sphere {0, 2, -0.15 scale <1,1,0.025> translate <0,0,-0.375>} 
	}
	blob {
		threshold 0.5
		cylinder {-z*0.5, -z*1.25, 0.05, 1}
		cylinder {-z*0.5, -z*1.5, 0.01, -1}
		sphere {0, 1, 1 scale <0.075,0.075,0.02> translate -z*1.1}
		sphere {0, 1, 1 scale <0.075,0.075,0.02> translate -z*1.15}
		sphere {0, 1, 1 scale <0.075,0.075,0.02> translate -z*1.2}
	}
}

#declare grill1 =
union {
        #declare i = 0;
        #while (i < 36)
               sphere_sweep {          
                        b_spline
                        6,   
                        <1.95,0,-0.3>,  0.12
                        <1.9,0,0.1>,    0.12
                        <1.3,0.5,0.2>,  0.12       
                        <0.8,0.55,0.2>, 0.06    
                        <0.3,0.6,0>,    0.036 
                        <0.2,0.5,-0.1>, 0.012 
                        tolerance 0.001       
                        rotate 10*y*i         
                                
                }
                #declare i = i+1;
        #end
        torus {1.95, 0.1} 
        object {sensor scale 5 rotate x*90 translate y*0.3}
        material {
                MetalMatG (<0.5,0.5,0.5>)
                interior {ior 1.5} 
                rotate x*90
                scale 10
        }
}

#declare sensors =
union {
        object {
                grill1
                scale 0.05
                rotate x*-90
                rotate y*-7.9
                translate <0.103,0,-3.18> 
        } 
        object {
                grill1
                scale 0.05*<-1,1,1>
                rotate x*-90
                rotate y*7.9
                translate <-0.103,0,-3.18> 
        }
} 

//_________________________________________________________________________________  // legs

#declare leg1 = 
union {
        sphere_sweep {
                cubic_spline 
                8,                           
                <0,0, 0>, 3
                <0,0, 2>, 2
                <0,0, 4>, 1.5
                <0,0, 6>, 1.25
                <0,0, 8>, 1.25
                <0,0,10>, 1.5
                <0,0,12>, 2
                <0,0,14>, 3
                scale <1.4,1.4,2.5>
                material {greebleMat scale 50 rotate x*90}
        }  
        sphere {
                <0,0,0>, 4 
                scale <0.5,1,1> 
                MetalMat (<1,0.85,0.2>)
        }
        sphere {
                <0,0,0>, 4.75 
                scale <0.2,1,1>
                material {greebleMat scale 50 rotate x*90}
        }                
        cylinder {
                <-1.8,0,0>, <1.8,0,0>, 3 
                MetalMat (<1,1,1>)
        }
        cylinder {
                <0,4.5,0>, <0,1,10>, 0.5
                material {greebleMat scale 50 rotate x*90}
        }        
        cylinder {
                <0,-4.5,0>, <0,-1,10>, 0.5
                material {greebleMat scale 50 rotate x*90}
        }
}   
    
#declare leg = 
union {
        object {leg1 rotate -15*x translate 35*z}
        object {leg1 rotate -15*x translate 35*z rotate -15*x translate 35*z}
        object {leg1 rotate -15*x translate 35*z rotate -15*x translate 35*z rotate -15*x translate 35*z}
}

#declare legs = 
union {    
        object {leg translate z*90 scale <1,-1,-1>}       
        object {leg translate z*-30 scale <1,-1,-1> rotate 120*y} 
        object {leg translate z*-30 scale <1,-1,-1> rotate 120*y scale <-1,1,1>}
        scale 0.011
        translate <0,-0.75,0>
}

//____________________________________________________________________________________________________  // whole shuttle

union {
        object {jets hollow}
        object {chassis hollow}
        object {sensors hollow}
        #if (landed) object {legs hollow} #end 
}

#end

